<template>
	<section class="main-body-wrapper">
     <div class="form-wrapper" id="loading" v-if="!accountsReady">
        <h1 class="text-center"> Loading accounts details..</h1>
          <div class="spinner">
            <div class="bounce1"></div>
            <div class="bounce2"></div>
            <div class="bounce3"></div>
            <div class="bounce4"></div>
            <div class="bounce5"></div>
            <div class="bounce6"></div>
          </div>
     </div>  
     
			<div class="container" v-if="accountsReady">
				<div class="page-title"  v-if="accounts.length>0">
					<h1>Select Payout Bank Account</h1>
					<h2 class="sub-title">Payments will be sent to this account.</h2>
				</div>
        <div class="page-title" v-else>
					<h1>Provide Payout Bank Account</h1>
					<h2 class="sub-title">Payments will be sent to this account.</h2>
				</div>

				<div class="form-wrapper">
					<div class="container-fluid"  v-if="accounts.length>0">
						<ul class="payout-list">
							<li class="payout-list-item"  v-for="(acc, index) in accounts"  :key="index"
										@click.prevent="selectAccount(index)">
								<input 
								type="radio"
								id="selected-account-1" 
								name="selector"
								v-model="accSelected.uiIndex"
								:value="(index)" 
								class="btn continue-btn"
								>
								<div class="check"></div>
								<label for="selected-account-1" class="btn continue-btn">
                  <div class="row m-0" id="selected-account-details">
                    <div class="col-md-6" id="account-number">
                      <p>Account Number</p>
                      <span>{{ acc.account_number }}</span>
                      <i class="name-of-bank">{{ acc.institution_name }}</i>
                    </div>
                    <div class="col-md-6" id="account-holder-details">
                      <!-- <p class="name-of-account">{{ acc.institution_name }}</p> -->
                      <span class="account-holder-name">{{ acc.category }} - {{ acc.type }}</span>
                      <i class="test-data"> {{ acc.account_nickname }}</i>
                    </div>
                  </div>
								</label>
							</li>
						</ul>
					</div>
				        <div class="container-fluid" :style="{ display: accounts.length==0 ? 'block' : 'none' }">
          <div class="row m-0">
            <div class="col-md-12 p-0">
              <div class="form-group">
                <label for="nameonaccount" class>
                  <span>Plan</span>
                  <i class="required-field float-left"></i>
                </label>
                <div class="input-wrapper">
                  <select
                    class="form-control plan-select"
                    name="entityType"
                    :class="getValidationClass('entityType')"
										v-model.lazy="$v.accSelected.entityType.$model"
                  >
                    <option value="Individual" >Individual</option>
                    <option value="business">Business</option>
										               

                  </select>
                     <span
                    class="success-icon"
                    v-if="$v.accSelected.entityType.$dirty && !$v.accSelected.entityType.$invalid"
                  >
                    <i class="fa fa-check-circle" aria-hidden="true"></i>
                  </span>
                  <span class="error-icon" v-if="$v.accSelected.entityType.$error">
                    <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                  </span>
                  <i
                    class="error-msg"
                    v-if="$v.accSelected.entityType.$dirty && !$v.accSelected.entityType.required"
                  >Please select a plan </i>
                </div>
              </div>
            </div>

            <div class="col-md-12 p-0">
              <div class="form-group">
                <label for="nameonaccount" class>
                  <span>Name on account</span>
                  <i class="required-field float-left"></i>
                </label>
                <div class="input-wrapper">
                  <input
                    v-model.lazy="$v.accSelected.nameOnAccount.$model"
                    type="text"
                    class="form-control"
                    id="name-on-account"
                    :class="getValidationClass('nameOnAccount')"
                    placeholder="Name on account"
                    name="nameonaccount"
                  >
                  <span
                    class="success-icon"
                    v-if="$v.accSelected.nameOnAccount.$dirty  && !$v.accSelected.nameOnAccount.$invalid"
                  >
                    <i class="fa fa-check-circle" aria-hidden="true"></i>
                  </span>
                  <span class="error-icon" v-if="$v.accSelected.nameOnAccount.$error">
                    <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                  </span>
                  <i
                    class="error-msg"
                    v-if="$v.accSelected.nameOnAccount.$dirty && !$v.accSelected.nameOnAccount.required"
                  >Please enter Name on account</i>
                </div>
              </div>
            </div>
            <div class="col-md-12 p-0">
              <div class="ppa-radio-wrap">
                <span class="custom-control custom-radio">
                  <input
                    v-model.lazy="$v.accSelected.accountType.$model"
                    value="Checking"
                    :class="getValidationClass('accountType')"
                    type="radio"        
                    class="custom-control-input"
                    id="checking"
                    name="radio-btn"
                  >
                  <label class="custom-control-label" for="checking">Checking</label>
                </span>
                <span class="custom-control custom-radio">
                  <input
                     v-model.lazy="$v.accSelected.accountType.$model"
                     :class="getValidationClass('accountType')"
                     value="Savings"
                     type="radio"
                     class="custom-control-input"
                     id="saving"
                     name="radio-btn"
                  >
                  <label class="custom-control-label" for="saving">Saving</label>
                </span>
                  <span
                    class="success-icon success-radio"
                    v-if="$v.accSelected.accountType.$dirty  && !$v.accSelected.accountType.$invalid"
                  >
                    <i class="fa fa-check-circle" aria-hidden="true"></i>
                  </span>
                  <span class="error-icon" v-if="$v.accSelected.accountType.$error">
                    <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                  </span>
                  <p><i
                    class="error-msg"
                    v-if="$v.accSelected.accountType.$dirty && !$v.accSelected.accountType.required"
                  >Please select a Entity</i></p>
              </div>
            </div>
            <div class="col-md-12 p-0">
              <div class="form-group">
                <label for="routingnumber" class>
                  <span>Routing number</span>
                  <i class="required-field float-left"></i>
                </label>
                <div class="input-wrapper">
                  <input
                    v-model.lazy="$v.accSelected.accountRouting.$model"
                    type="text"
                    class="form-control"
                    id="routing-number"
                    :class="getValidationClass('accountRouting')"
                    placeholder="Routing number"
                    name="routingnumber"
                  >
                  <span
                    class="success-icon"
                    v-if="$v.accSelected.accountRouting.$dirty  && !$v.accSelected.accountRouting.$invalid"
                  >
                    <i class="fa fa-check-circle" aria-hidden="true"></i>
                  </span>
                  <span class="error-icon" v-if="$v.accSelected.accountRouting.$error">
                    <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                  </span>
                  <i
                    class="error-msg"
                    v-if="$v.accSelected.accountRouting.$dirty && !$v.accSelected.accountRouting.required"
                  >Please enter Routing Number</i>
                </div>  
              </div>
            </div>
            <div class="col-md-12 p-0">
              <div class="form-group">
                <label for="accountnumber" class>
                  <span>Account number</span>
                  <i class="required-field float-left"></i>
                </label>
                <div class="input-wrapper">
                  <input
                    v-model.lazy="$v.accSelected.accountNumber.$model"
                    type="text"
                    class="form-control"
                    :class="getValidationClass('accountNumber')"
                    id="account-number"
                    placeholder="Account number"
                    name="accountnumber"
                  >
                  <span
                    class="success-icon"
                    v-if="$v.accSelected.accountNumber.$dirty  && !$v.accSelected.accountNumber.$invalid"
                  >
                    <i class="fa fa-check-circle" aria-hidden="true"></i>
                  </span>
                  <span class="error-icon" v-if="$v.accSelected.accountNumber.$error">
                    <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                  </span>
                  <i
                    class="error-msg"
                    v-if="$v.accSelected.accountNumber.$dirty && !$v.accSelected.accountNumber.required"
                  >Please enter Account Number</i>
                </div>
              </div>
            </div>
            <div class="col-md-12 p-0">
              <div class="form-group">
                <label for="confirmaccountnumber" class>
                  <span></span>
                  <i class="required-field float-left"></i>
                </label>
                <div class="input-wrapper" >
                  <input
                    v-model.lazy="$v.accSelected.accountNumberConfirmation.$model"
                    type="text"
                    :class="getValidationClass('accountNumberConfirmation')"
                    class="form-control"
                    id="confirm-account-number"
                    placeholder="Confirm account number"
                    name="confirmaccountnumber"
                  >
							      <span
                    class="success-icon"
                    v-if="$v.accSelected.accountNumberConfirmation.$dirty  && !$v.accSelected.accountNumberConfirmation.$invalid"
                  >
                    <i class="fa fa-check-circle" aria-hidden="true"></i>
                  </span>
                  <span class="error-icon" v-if="$v.accSelected.accountNumberConfirmation.$error">
                    <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                  </span>
                  <i
                    class="error-msg"
                    v-if="$v.accSelected.accountNumberConfirmation.$dirty && !$v.accSelected.accountNumberConfirmation.required"
                  >Please enter Account number again</i> 
                  <i
                    class="error-msg"
                    v-else-if="$v.accSelected.accountNumberConfirmation.$dirty && !$v.accSelected.accountNumberConfirmation.sameAsAccount"
                  >Account number should be entered same as above</i> 
                </div>
              </div>
            </div>
          </div>
        </div>
          
         
				<div class="container-fluid">
					<div class="row m-sm-0  pt-3">
						<div class="col-lg-6 col-md-12 p-0">
							<div class="previous-step-wrap">
								<a href v-on:click.prevent="back" class="previous-step">Previous Step</a>
							</div>
						</div>
						<div class="col-lg-6 col-md-12 p-0">
							<div class="continue-btn-wrap">
								<button 
                  type="submit" 
                  class="btn continue-btn"
                  :disabled="accounts.length>0 ? accSelected.uiIndex==null : $v.$anyError "
                  v-on:click.prevent="next"
                >Continue</button>
							</div>
						</div>
					</div>
				</div>
				</div>


			</div>
		</section>
</template>

<script>
import { required, sameAs,minLength, between, email } from "vuelidate/lib/validators";

export default {
  name: 'BankForm',
  data () {
    return {
      token: localStorage.getItem('token'),
      type: localStorage.getItem('type'),
      accounts: [],
      accountsReady: false,
      accSelected: {
        uiIndex: null, 
        accountId: null,
        accountRouting: null,
        accountNumber: null, 
        accountType: null, //checking or saving
        entityType: null, //Individual or Business
        accountNickname: null,
				nameOnAccount: null,
				accountNumberConfirmation:null
      }
    }
	},
	  validations: {
			accSelected: {
				nameOnAccount: {
					required
				},
				accountRouting: {
					required
				},
				entityType:{
					required
				},
				accountType:{
					required
				},
				accountNumber: {
					required
				},
				accountNumberConfirmation:{
						required,
						sameAsAccount: sameAs('accountNumber')
				}
		},
  },
  mounted () {
    this.refreshAccounts()
  }, 
  methods: {
		getValidationClass(fieldName) {
      	const field = this.$v.accSelected[fieldName];
				if (field) {
					return field.$dirty && field.$invalid
						? "error-brdr"
						: field.$dirty && !field.$invalid
						? "success-brdr"
						: "";
				}
		},
    refreshAccounts: function() {
      let that=this
      let setting = {
          "url": "/onboarding/connections/accounts",
          "method": "GET",
          "headers": { "authorization": "Bearer " + that.token}
      }
      //loading accounts and details to display in page
      that.$axios(setting).then(response => {
          that.accountsReady=true
          console.log("accounts:---")
          console.log(response.data)
          that.accounts=response.data.accounts
        }).catch(error => {
            let logObject = {module: "onboarding",error: error, details: {page: "bankForm.refreshAccounts",endpoint: "/onboarding/connections/accounts",data:{}}};
            this.$store.commit('logError', logObject);
        })
    },

    selectAccount: function(index) {
      this.accSelected.uiIndex=index
      this.accSelected.accountId = this.accounts[index].id
      this.accSelected.accountRouting = this.accounts[index].routing
      this.accSelected.accountNumber = this.accounts[index].account_number
      this.accSelected.accountType = this.accounts[index].type
      this.accSelected.entityType = "Business"
      this.accSelected.nameOnAccount = this.accounts[index].account_nickname
			this.accSelected.accountNickname = this.accounts[index].account_nickname
			
			this.accountNumberConfirmation =  this.accounts[index].account_number
      
    },
    
    next: function() {
      if(this.accounts.length==0){
          this.$v.accSelected.$touch();
          if(this.$v.$anyError){
             this.$toasted.show('There are form errors, please check',{
                  type : 'error',
                  duration : 3000,
                  position: "top-right", 
              })   
            return false;
          }
      }
      let that=this
     let data={
            "accountId": this.accSelected.accountId,
            "accountRouting": this.accSelected.accountRouting,
            "accountNumber": this.accSelected.accountNumber,
            "accountType": this.accSelected.accountType,
            "entityType": this.accSelected.entityType,
            "nameOnAccount": this.accSelected.nameOnAccount,
            "accountNickname": this.accSelected.accountNickname
      }
      let setting = {
          "url": "/onboarding/accounts/payout",
          "method": "POST",
          "headers": { "authorization": "Bearer " + that.token},
          "data": data
        }

          
        console.log(setting)
        //loading accounts and details to display in page
        that.$axios(setting).then(response => {
            console.log("payout:---")
            console.log(response.data)
            that.handler=null
            this.$store.commit('setStepProgress', {step:3,status:  'completed'})
            that.$router.push({"name": "Checks"})
          }).catch(error => {
            let logObject = {module: "onboarding",error: error, details: {page: "bankForm.next",endpoint: "/onboarding/accounts/payout",data: data}};
            this.$store.commit('logError', logObject);
          })


    },

     back: function() {
      this.handler=null
      this.$router.push({"name": "ConnectToBank" })
    }

  }

}
</script>